/* es000_infiniti_thread_senza_join.c  */

/* messi anche nella riga di comando del compilatore */
#ifndef _THREAD_SAFE
#define _THREAD_SAFE
#endif
#ifndef _REENTRANT
#define _REENTRANT
#endif

#ifdef  _POSIX_C_SOURCE
#if     _POSIX_C_SOURCE < 200112L
#undef  _POSIX_C_SOURCE
#define _POSIX_C_SOURCE 200112L
#endif
#else
#define _POSIX_C_SOURCE 200112L
#endif


#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
/* per uintptr_t */
#include <stdint.h>
/* PRIiPTR */
#include <inttypes.h>
/* per strerror_r */
#include <string.h>
#include <pthread.h>

void *PrintHello(void *arg)
{
	printf(" %"  PRIuPTR ": Hello World! \n", (uintptr_t)arg );
	pthread_exit (NULL);
}

int main()
{
	pthread_t tid;
	int rc;
	uintptr_t t;
	for(t=0;;t++){
		printf("Creating thread %" PRIuPTR "\n", t);
		rc = pthread_create (&tid, NULL, PrintHello, (void*)t );
		if (rc){char msg[100];
			strerror_r(rc,msg,100);
			printf("pthread_create failed : %s\n", msg );
			exit(1);
		}
	}

	pthread_exit (NULL);
	return(0);
}
